#-#-#-#-#-#-#-#-#-#-#-#
#  Creature Combat    #
#  1.19.2             #
#-#-#-#-#-#-#-#-#-#-#-#

execute as @a[tag=health] at @s run attribute @s generic.max_health base set 40
execute as @a[tag=!health] at @s run attribute @s generic.max_health base set 20
execute as @a[tag=health,scores={lifesteal=53..},nbt={SelectedItem:{id:"minecraft:iron_sword",Count:1b,tag:{Lifesteal:1}}}] at @s run setblock -1375 50 1470 redstone_block
execute as @a[tag=health,scores={lifesteal=53..},nbt={SelectedItem:{id:"minecraft:iron_sword",Count:1b,tag:{Lifesteal:1}}}] at @s run setblock -1375 50 1470 air
execute as @a[tag=health,scores={lifesteal=1..},nbt={SelectedItem:{id:"minecraft:iron_sword",Count:1b,tag:{Lifesteal:1}}}] at @s run scoreboard players set @s lifesteal 0
execute as @a[tag=overpowered] at @s run function mobbattle:armor_effects/op_helmet
execute as @a[tag=life-and-death,scores={gCarrotLD=1..}] at @s run function mobbattle:armor_effects/life_and_death
execute as @a[tag=life-and-death] run function mobbattle:armor_effects/life_and_death_sword
execute as @a[tag=life-and-death] at @s run function mobbattle:armor_effects/life_and_death_armor
execute as @a[tag=supernova] at @s run function mobbattle:armor_effects/supernova
execute as @a[tag=king-midas,scores={kingMidasDamage=250..}] at @s run function mobbattle:armor_effects/king_midas
execute as @a[tag=king-midas,scores={kingMidasEffect=1..}] at @s run function mobbattle:armor_effects/king_midas_effect
execute as @a[tag=firebreather,scores={waitTorch=21..,throwTorch=1..}] at @s run function mobbattle:armor_effects/firebreather_torch
execute as @a[tag=firebreather] at @s run function mobbattle:armor_effects/firebreather
execute as @a[tag=star-of-extinction] at @s run function mobbattle:armor_effects/star_of_extinction
execute as @a[tag=time-traveler] at @s run function mobbattle:armor_effects/time_traveler
execute as @a[tag=virus] at @s run function mobbattle:armor_effects/virus
execute as @a[tag=black-hole] at @s run function mobbattle:armor_effects/black_hole
execute as @a[tag=elemental] at @s run function mobbattle:armor_effects/elemental

execute as @a store result score @s diamonds run clear @s diamond 0
execute as @a store result score @s emeralds run clear @s emerald 0
execute as @a store result score @s nether_stars run clear @s nether_star 0

execute as @a[scores={sneaking=1..},nbt={Inventory:[{id:"minecraft:compass",Count:1b,tag:{display:{Lore:['{"text":"Makes creatures around you glow when shifting","italic":false,"color":"aqua"}'],Name:'{"text":"Glowing Compass","italic":false}'}}}]}] at @s run function mobbattle:armor_effects/glowingcompass
execute as @a[scores={openTrappedChest=1..}] at @s run setblock -1413 59 1418 air destroy
execute as @a[scores={openTrappedChest=1..}] at @s run stopsound @a * block.chest.open
execute as @a[scores={openTrappedChest=1..}] at @s run playsound block.amethyst_block.hit block @a ~ ~ ~ 1 1 1
execute as @a[scores={openTrappedChest=1..}] at @s run scoreboard players set @a openTrappedChest 0

execute as @a[scores={playGame=..2400,usedWarpedFungus=1..},nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick",tag:{CustomModelData:1}}}] at @s run function mobbattle:portals/random_portal
execute as @a[scores={playGame=..2400,usedWarpedFungus=1..},nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick",tag:{CustomModelData:1}}}] at @s run function mobbattle:portals/random_portal
execute as @a[scores={playGame=..2400,usedWarpedFungus=1..}] at @s run scoreboard players set @a usedWarpedFungus 0
execute as @a[scores={playGame=..2400,usedWarpedFungus=1..}] at @s run scoreboard players set @a usedWarpedFungus 0

execute at @e[type=tnt,nbt={Fuse:1s}] if entity @e[type=tnt,nbt={Fuse:1s}] run summon minecraft:creeper ~ ~ ~ {CustomName:'{"text":"TNT"}',Fuse:1s,ignited:1b,ActiveEffects:[{Id:14b,Duration:20}]}
kill @e[type=tnt,nbt={Fuse:1s}]
kill @e[type=area_effect_cloud,nbt={Effects:[{Id:14b,Duration:20}]}]

execute unless entity @a[scores={Health=1..4}] at @a run setblock -1429 50 1403 air
execute if entity @a[scores={Health=1..4}] at @a run setblock -1429 50 1403 redstone_block

kill @e[x=-1472,y=53,z=1460,dx=-16,dy=-3,dz=5,type=arrow,nbt={inGround:1b}]

execute if entity @a[tag=PlatformE] run fill -1421 58 1391 -1425 58 1395 light_blue_concrete
execute if entity @a[tag=PlatformH] run fill -1421 58 1391 -1425 58 1395 light_blue_concrete
execute if entity @a[tag=!PlatformE,tag=!PlatformH] run fill -1421 58 1391 -1425 58 1395 light_gray_concrete

execute as @a[tag=longer_games,scores={playGame=2398,ExtendedGame=0}] at @s run function mobbattle:crises/reset_game
execute as @a[scores={playGame=1},tag=negative_effect] at @s run function mobbattle:random_generators/negative_status_effect
execute as @a[tag=remove_enchants] at @s run function mobbattle:challenge_item_remove_enchants

execute as @a[scores={emptyChest=600..}] at @s run setblock -1412 59 1418 chest[facing=west] replace
execute as @a[scores={emptyChest=600..}] at @s run particle dust 0.6 0.035 0.035 0.7 -1412 60 1418 0.5 0.2 0.5 0.5 100
execute as @a[scores={emptyChest=600..}] at @s run playsound block.shulker_box.close master @a -1412 59 1418 0.5 0.5
execute as @a[scores={emptyChest=600..}] at @s run scoreboard players set @a emptyChest 0

execute as @a[nbt={Inventory:[{id:"minecraft:slime_ball"}]}] at @s run particle item_slime ~ ~-0.2 ~ 0.1 0.1 0.1 0.1 5 normal
execute as @e[type=#mobbattle:creatures] at @s if entity @a[distance=..5,nbt={Inventory:[{id:"minecraft:slime_ball"}]}] run effect give @s wither 2 0
execute as @e[type=#mobbattle:creatures] at @s if entity @a[distance=..5,nbt={Inventory:[{id:"minecraft:slime_ball"}]}] run effect give @s slowness 1 0
execute as @a[scores={Health=1..4},nbt={Inventory:[{id:"minecraft:phantom_membrane"}]}] at @s run effect give @s regeneration 1 0
execute as @a[scores={Health=1..4},nbt={Inventory:[{id:"minecraft:phantom_membrane"}]}] at @s run effect give @s speed 1 1
execute as @e[type=#mobbattle:creatures,tag=!dummy,tag=!Tutorial] at @s if entity @a[scores={difficulty=0},nbt={Inventory:[{id:"minecraft:heart_of_the_sea"}]}] run data merge entity @s {DeathLootTable:"mobbattle:entities/creature_upgraded"}
execute as @e[type=#mobbattle:creatures,tag=!dummy,tag=!Tutorial] at @s if entity @a[scores={difficulty=1},nbt={Inventory:[{id:"minecraft:heart_of_the_sea"}]}] run data merge entity @s {DeathLootTable:"mobbattle:entities/creature_hard_upgraded"}
execute as @e[type=#mobbattle:creatures,tag=!dummy,tag=!Tutorial] at @s unless entity @a[nbt={Inventory:[{id:"minecraft:heart_of_the_sea"}]}] run data merge entity @s {DeathLootTable:"mobbattle:entities/creeper"}
execute as @a[nbt={Inventory:[{id:"minecraft:totem_of_undying",Count:1b}]}] at @s run scoreboard players set @s hasTotem 1
execute as @a[scores={playGame=2400..},nbt=!{Inventory:[{id:"minecraft:totem_of_undying",Count:1b}]}] at @s run scoreboard players set @s hasTotem 0

execute store result score @a players run execute if entity @a
execute as @a[limit=1,sort=nearest,tag=!player1,tag=!player2,tag=!player3,tag=!player4] at @s unless entity @a[tag=player1] run tag @s add player1
execute as @a[limit=1,sort=nearest,tag=!player1,tag=!player2,tag=!player3,tag=!player4] at @s unless entity @a[tag=player2] run tag @s add player2
execute as @a[limit=1,sort=nearest,tag=!player1,tag=!player2,tag=!player3,tag=!player4] at @s unless entity @a[tag=player3] run tag @s add player3
execute as @a[limit=1,sort=nearest,tag=!player1,tag=!player2,tag=!player3,tag=!player4] at @s unless entity @a[tag=player4] run tag @s add player4
execute as @a[scores={players=2..}] at @s run scoreboard players operation @a[tag=!player1] playGame = @a[tag=player1] playGame

stopsound @a * minecraft:item.armor.equip_generic

execute if entity @e[type=item] run function mobbattle:artifact
execute as @e[type=#mobbattle:creatures,tag=dummy] at @s run data merge entity @s {DeathLootTable:"minecraft:empty"}
execute as @e[type=#mobbattle:creatures,nbt={DeathLootTable:"minecraft:entities/creeper"}] at @s run data merge entity @s {DeathLootTable:"mobbattle:entities/creeper"}
execute as @e[type=#mobbattle:creatures,nbt={DeathLootTable:"minecraft:entities/skeleton"}] at @s run data merge entity @s {DeathLootTable:"mobbattle:entities/creeper"}
execute as @e[type=#mobbattle:creatures,nbt={DeathLootTable:"minecraft:entities/wither_skeleton"}] at @s run data merge entity @s {DeathLootTable:"mobbattle:entities/creeper"}
execute as @e[type=#mobbattle:creatures,nbt={DeathLootTable:"minecraft:entities/drowned"}] at @s run data merge entity @s {DeathLootTable:"mobbattle:entities/creeper"}
execute as @e[type=creeper] at @s run data merge entity @s {ArmorDropChances:[0.0F,0.0F,0.0F,0.0F]}
execute as @e[type=skeleton] at @s run data merge entity @s {ArmorDropChances:[0.0F,0.0F,0.0F,0.0F]}
execute as @e[type=skeleton] at @s unless entity @a[scores={playGame=..2400}] unless entity @s[type=skeleton,nbt={HandItems:[{id:"minecraft:bow",Count:1b,tag:{CustomModelData:2}},{}]}] run data merge entity @s {HandDropChances:[0.0F,0.0F],HandItems:[{id:"minecraft:bow",Count:1b,tag:{CustomModelData:2}},{}]}
execute as @e[type=drowned] at @s run data merge entity @s {ArmorDropChances:[0.0F,0.0F,0.0F,0.0F]}
execute as @e[type=wither_skeleton] at @s run data merge entity @s {ArmorDropChances:[0.0F,0.0F,0.0F,0.085F]}
execute as @e[type=wither_skeleton] at @s unless entity @a[scores={playGame=..2400}] if entity @s[type=wither_skeleton,nbt={HandItems:[{id:"minecraft:bow",Count:1b},{}]}] unless entity @s[type=wither_skeleton,nbt={HandItems:[{id:"minecraft:bow",Count:1b,tag:{CustomModelData:2}},{}]}] run data merge entity @s {HandDropChances:[0.0F,0.0F],HandItems:[{id:"minecraft:bow",Count:1b,tag:{CustomModelData:2}},{}]}

execute as @a[scores={PlayGameMode=1,ticksToSeconds=20}] at @s run scoreboard players add @a secondsPlayed 1
execute as @a[scores={PlayGameMode=1,ticksToSeconds=20..}] at @s run scoreboard players reset @a ticksToSeconds